MOTION		= $1534
IMAGE	= $1602
Y_LOW		= $151C
Y_HIGH		= $1594
EXTRA_BITS	= $7FAB10
STOP_TIMER	= $1558

	dcb "INIT"
	LDA #$08
	STA $1504,x	;WFl[^[orXvCg
	RTL

	dcb "MAIN"
	PHB
	PHK
	PLB
	JSR ROTINE_START
	PLB
	RTL

ROTINE_START:
	JSR SUB_GFX
	LDA $14C8,x
	CMP #$08
	BNE RETURN_0
	LDA #$06	;sub off screen x0
	JSL $1D801C	;off screen
	LDA $9D
	BNE RETURN_0
	LDA STOP_TIMER,x
	BNE RETURN_0
	LDA MOTION,x
	JSL $0086DF
MOTION_POS_TXT	dcw MOTION_0&$FFFF,MOTION_1&$FFFF,MOTION_2&$FFFF,MOTION_3&$FFFF
			dcw MOTION_4&$FFFF,MOTION_5&$FFFF,MOTION_6&$FFFF
MOTION_0:
	LDA $94
	SEC
	SBC $E4,x
	LDA $95
	SBC $14E0,x
	ROL
	ROL
	AND #$01
	EOR #$01
	STA $157C,x
	LDA $D8,x
	STA Y_LOW,x
	LDA $14D4,x
	STA Y_HIGH,x
INC_MOTION:
	INC MOTION,x
RETURN_0:
	JSR RIDE_SPRITE
	RTS
MOTION_1:
	LDA #$F8
	JSR SET_AA
	CMP #$04
	BNE RETURN_0
	LDA #$20
STORE_TIMER:
	STA STOP_TIMER,x
	BRA INC_MOTION

MOTION_2:
	LDA #$F8
	JSR SET_AA
	CMP #$10
	BNE RETURN_0
	LDA #$18
	BRA STORE_TIMER
MOTION_4:
	JSR GEN_EXTRA
MOTION_3:
	LDA #$10
INC_IMAGE:
	INC IMAGE,x
	BRA STORE_TIMER
MOTION_5:
	STZ IMAGE,x
	LDA #$08
	JSR SET_AA
	BNE RETURN_0
	STZ MOTION,x
	LDA #$40
	STA STOP_TIMER,x
	LDA $1504,x
	STA $14C8,x
	RTS
MOTION_6:
	JSL $01802A
	RTS
SET_AA:
	STA $AA,x
	JSL $01801A
	LDA Y_LOW,x
	SEC
	SBC $D8,x
	RTS

SUB_VERT_POS:
	LDA $14D4,x
	XBA
	LDA $D8,x
	REP #$20
	SEC
	SBC.W #$0010
	SEC
	SBC $96
	BIT.W #$FF00
	BNE OVER_100
	SEP #$20
	LSR
	STA $00
	RTS
OVER_100:
	SEP #$20
	STZ $00
	RTS

RIDE_SPRITE:
	JSL $01A7DC
	BCC NOT_CONTACT
	LDA $96
	SEC
	SBC $D8,x
	CMP #$E6
	BPL SPRITE_WINS
	LDA $7D
	BMI NOT_CONTACT
	LDA $164A,x
	BNE RIDE_THIS
	LDA MOTION,x
	CMP #$02
	BCS STOMP_SPRITE
RIDE_THIS:
	LDA #$01
	STA $1471
	LDA #$06
	STA $154C,x
	STA $164A,x
	STZ $7D
	LDA #$E1
	LDY $187A
	BEQ NO_YOSHI
	LDA #$D1
NO_YOSHI:
	CLC
	ADC $D8,x
	STA $96
	LDA $14D4,x
	ADC #$FF
	STA $97
	RTS
NOT_CONTACT:
	STZ $164A,x
	RTS
SPRITE_WINS:
	LDA $1490
	BNE HAS_STAR
	JSL $00F5B7
	RTS
KILLED_X_SPEED	dcb $F0,$10
STAR_SOUNDS		dcb $13,$14,$15,$16,$17,$18,$19
HAS_STAR:
	STZ $14C8,x
	LDA #$D0
	STA $AA,x
	LDY #$00
	LDA $96
	SEC
	SBC $E4,x
	STA $0F
	LDA $97
	SBC $14E0,x
	BPL RETURN_VERT
	INY
RETURN_VERT:
	LDA KILLED_X_SPEED,y
	STA $B6,x
	INC $18D2
	LDA $18D2
	CMP #$08
	BCC NO_RESET2
	LDA #$08
	STA $18D2
NO_RESET2:
	JSL $02ACE5
	LDY $18D2
	CPY #$08
	BCS NO_SOUND2
	LDA STAR_SOUNDS-1,y
	STA $1DF9
NO_SOUND2:
	RTS
STOMP_SPRITE:
	LDA $1697
	CLC
	ADC $1626,x
	INC $1697
	TAY
	INY
	CPY #$08
	BCS NO_SOUND
	LDA STAR_SOUNDS-1,y
	STA $1DF9
NO_SOUND:
	TYA
	CMP #$08
	BCC NO_RESET
	LDA #$08
NO_RESET:
	JSL $02ACE5
	JSL $01AA33
	JSL $01AB99
	LDA $140D
	ORA $187A
	BEQ NOT_SPIN
	LDA #$1F
	STA $1540,x
	JSL $07FC3B
	LDA #$08
	STA $1DF9
	LDA #$04
	STA $14C8,x
	LDA #$FC
	STA $7D
	BRA END_STOMP
NOT_SPIN:
	LDA #$02
	STA $14C8,x
END_STOMP:
	LDA #$FF
	STA $161A,x
	LDA #$06
	STA MOTION,x
	RTS

STOMP_GFX:
	LDA $00
	STA $0300,y
	STA $0304,y
	LDA $01
	STA $0301,y
	CLC
	ADC #$10
	STA $0305,y
	LDA #$C0
	STA $0302,y
	LDA #$C2
	STA $0306,y
	LDA $14
	ASL A
	ASL A
	ASL A
	ASL A
	ASL
	AND #$40
	ORA #$33
	STA $0303,y
	STA $0307,y
	LDA #$01
	LDY #$02
	JMP SET_GFX_JUMP
TILE_X		dcb $00,$08,$03,$05,$00,$08
TILE_Y		dcb $08,$05,$08
TILE_POS	dcb $F0,$F1,$F2
EXTRA_X	dcb $06,$03
SUB_GFX:
	JSL $1D8018	;draw info
	LDA Y_LOW,x
	SEC
	SBC $1C
	STA $03
	LDA $157C,x	;
	STA $04
	CLC
	ROR
	ROR
	ROR
	STA $02
	LDA MOTION,x
	CMP #$06
	BEQ STOMP_GFX
	LDA #$02
	STA $06
	LDA IMAGE,x
	STA $05
	LDA EXTRA_BITS,x
	AND #$04
	STA $07
	PHX
	TYA
	LSR A
	LSR A
	TAX
	LDA $05
	CMP #$01
	BNE NOT_EXTRA
;+++++++++++++++
; first tile   +
;+++++++++++++++
	JSR EXTRA_TILE
NOT_EXTRA:
	LDA $07
	BEQ NOT_SET_GROUND
	LDA $00
	STA $0300,y
	LDA $03
	STA $0301,y
	LDA #$C4
	STA $0302,y
	LDA #$2D
	STA $0303,y
	LDA #$02
	STA $0460,x
	INY
	INY
	INY
	INY
	INX
NOT_SET_GROUND:
	LDA $00
	STA $0304,y
	LDA $01
	STA $0305,y
	LDA #$E3
	STA $0306,y
	LDA #$23
	ORA $02
	STA $0307,y
	STA $0303,y
;+++++++++++++++
; second tile  +
;+++++++++++++++
SECOND_GFX:
	PHX
	LDA $05
	TAX
	LDA TILE_Y,x
	CLC
	ADC $01
	STA $0301,y
	LDA TILE_POS,x
	STA $0302,y

	TXA
	ASL
;	CLC
	ADC $04
	TAX
	LDA TILE_X,x
	CLC
	ADC $00
	STA $0300,y

	PLX
	STZ $0460,x
	LDA #$02
	STA $0461,x
	PLX

	LDA $06
	LDY #$FF
SET_GFX_JUMP:
	JSL $01B7B3
	RTS
;+++++++++++++++
; Extra tile   +
;+++++++++++++++
EXTRA_TILE:
	INC $06
	LDA $04
	PHX
	TAX
	LDA EXTRA_X,x
	PLX
	CLC
	ADC $00
	STA $0300,y
	LDA #$FD
	CLC
	ADC $01
	STA $0301,y
	LDA #$E0
	STA $0302,y
	LDA #$23
	STA $0303,y
	STZ $0460,x

	INY
	INY
	INY
	INY
	INX
	RTS
GEN_X_OFFSET	dcb $FC,$0E
GEN_X_OFFSET2	dcb $FF,$00
GEN_X_SPEED	dcb $F0,$10
GEN_EXTRA:
	LDY #$07
EXTRA_LOOP:
	LDA $170B,y
	BEQ EXTRA_1
	DEY
	BPL EXTRA_LOOP
	RTS
EXTRA_1:
	LDA $157C,x
	REP #$20
	AND.W #$0001
	ASL
	ASL
	ASL
	SEC
	SBC.W #$0004
	STA $00
	SEP #$20

	LDA #$09
	STA $170B,y
	PHY
	LDA $157C,x
	TAY
	LDA $E4,x
	CLC
	ADC GEN_X_OFFSET,y
	PLY
	STA $171F,y
	PHY
	LDA $157C,x
	TAY
	LDA $14E0,x
	ADC GEN_X_OFFSET2,y
	PLY
	STA $1733,y
	LDA $D8,x
	STA $1715,y
	LDA $14D4,x
	STA $1729,y
	LDA #$00
	STA $173D,y
	PHY
	LDA $157C,x
	TAY
	LDA GEN_X_SPEED,y
	PLY
	STA $1747,y	;x speed
	JSR SUB_VERT_POS
	LDA $00
	STA $176F,y
;++++++++++++++++++++++++++++++++++++++++++
	JSL $029D9D				;+
RETURNe:					;+ NEVER write any futher!(label is OK)
	RTS					;+ <=RTL is OK, too.
;++++++++++++++++++++++++++++++++++++++++++
;and, the following code of RTS is ExtraSprite's rotine.


;++++++++++++++++++++++++
; Extra sprite code JSL
;++++++++++++++++++++++++
	PHB
	PHK
	PLB
	JSR EX_ROTINE
	PLB
	RTL

;+++++++++++++++++++++++++++++
; MAIN EXTRA sprite's ROTINE
;+++++++++++++++++++++++++++++
DEL_EX_SPRITE:
	STZ $170B,x
EX_RETURN:
	RTS

EX_ROTINE:
	LDA #$0D
	STA $170B,x
	JSL $029DC8	;This sprite contact with mario & cape as much as Chuck's baseball.
	LDA $170B,x
	CMP #$0D
	BNE EX_RETURN	;if this sprite became smoke, jump to EX_RETURN
	LDA #$09
	STA $170B,x

	JSR EX_GFX_ROTINE
	LDA EX_OFFSCREEN
	BMI DEL_EX_SPRITE
	LDA $9D
	BNE EX_RETURN
	STZ $173D,x
	LDA $176F,x
	BEQ EX_NOT_SET_Y
	LDA #$F0
	STA $173D,x
	JSL $029DD4	;get y
EX_NOT_SET_Y:
	JSL $029DD0	;get x
	INC $1765,x	;timer
	LDA $1765,x
	AND #$0F
	STA $1765,x
	RTS


EX_X_OFFSET	= $0290
EX_Y_OFFSET	= $0291
EX_TILEMAP	= $0292
EX_PROPERTY	= $0293
EX_TILESIZE	= $0444
EX_SPRITE_XLO	= $171F
EX_SPRITE_YLO	= $1715
EX_SPRITE_XHI	= $1733
EX_SPRITE_YHI	= $1729
EX_OFFSCREEN	= $00
EX_PROP_TXT	dcb $23,$23,$23,$63,$23,$23,$63,$63
EX_TILE_TXT	dcb $E0,$E1,$E2,$E1,$E0,$E1,$E2,$E1
;++++++++++++++++++++++++++++++++++++++++
; $170B+x is this sprite ($00<&=x<&=$07)
;++++++++++++++++++++++++++++++++++++++++
;It is possible to use it freely only by one tile.
EX_GFX_ROTINE:
	LDA $1765,x
	LSR A
	TAY
	LDA EX_PROP_TXT,y
	STA $01
	LDA $1747,x
	AND #$80
	EOR #$80
	LSR A
	EOR $01
	STA $01
	LDA EX_TILE_TXT,y
	STA $02
	JSR EX_DRAW_INFO
	LDA $01
	STA EX_PROPERTY,y
	LDA $02
	STA EX_TILEMAP,y
	RTS

EX_DRAW_INFO:
	STZ EX_OFFSCREEN
	STZ EX_TILESIZE,x
	LDA EX_SPRITE_XLO,x
	CMP $1A
	LDA EX_SPRITE_XHI,x
	SBC $1B
	BEQ EX_ON_SCREEN_X
	INC EX_TILESIZE,x
EX_INC_ONLY:
	INC EX_OFFSCREEN	;over screen x => EX_OFFSCREEN = $01 
EX_ON_SCREEN_X:
	LDA EX_SPRITE_XHI,x
	XBA
	LDA EX_SPRITE_XLO,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC.W #$0040
	BMI EX_INVALID
	CMP.W #$0180
	BCS EX_INVALID
	SEP #$20
	LDA EX_SPRITE_YHI,x
	XBA
	LDA EX_SPRITE_YLO,x
	REP #$20
	SEC
	SBC $1C
	CLC
	ADC.W #$0010
	BMI NOT_WRITE_GFX
	CMP.W #$0100
	BCS NOT_WRITE_GFX
	SEP #$20
	TXA
	ASL A
	ASL A
	TAY
	LDA EX_SPRITE_XLO,x
	SEC
	SBC $1A
	STA EX_X_OFFSET,y
	LDA EX_SPRITE_YLO,x
	SEC
	SBC $1C
	STA EX_Y_OFFSET,y
	RTS

EX_INVALID:
	SEP #$20
	LDA #$80
	TSB EX_OFFSCREEN	;not write gfx => EX_OFFSCREEN = $8?(=Minus)
NOT_WRITE_GFX:
	SEP #$20
	PLA
	PLA
	RTS










